unit Terminal;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, RusErrorStr,
  StdCtrls, ExtCtrls, Registry, About, ActnList, ComCtrls, ToolWin, Menus,
  Variants, Graphics;

const
  ProgrammVersion = 'Terminal v1.0';

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    MainMenu1: TMainMenu;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure N4Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//**************

var
  CommProp : TCommProp;
  CommTimeouts : TCommTimeouts;
  DCB : TDCB;
  hComm : Cardinal;             //   
  ResBool : Boolean;
  hReadCom : Cardinal;
  inChar :array[0..MAXWORD] of Char;
  ThreadID : Cardinal = 0;
  ReadenBytes : Cardinal;

//**************

procedure TForm1.Button1Click(Sender: TObject);

begin
// 
  hComm:=CreateFile(PChar(ComboBox1.Items[ComboBox1.ItemIndex]),
  GENERIC_READ or GENERIC_WRITE,0,Nil,OPEN_EXISTING,0,0);

//,   ?
  if hComm = INVALID_HANDLE_VALUE then
  begin
    SysErrorMessage(GetLastError);
    CloseHandle(hComm);
    hComm:=0;
    exit;
  end
  else
  begin
    ResBool:=GetCommState(hComm,DCB);
    if ResBool = false then
    begin
      SysErrorMessage(GetLastError);
      CloseHandle(hComm);
      hComm:=0;
      exit;
    end;
  end;

  case ComboBox2.ItemIndex of
    0 : DCB.BaudRate:= CBR_110;
    1 : DCB.BaudRate:= CBR_300;
    2 : DCB.BaudRate:= CBR_600;
    3 : DCB.BaudRate:= CBR_1200;
    4 : DCB.BaudRate:= CBR_2400;
    5 : DCB.BaudRate:= CBR_4800;
    6 : DCB.BaudRate:= CBR_9600;
    7 : DCB.BaudRate:= CBR_14400;
    8 : DCB.BaudRate:= CBR_19200;
    9 : DCB.BaudRate:= CBR_38400;
    10 : DCB.BaudRate:= CBR_56000;
    11 : DCB.BaudRate:= CBR_57600;
    12 : DCB.BaudRate:= CBR_115200;
    13 : DCB.BaudRate:= CBR_128000;
    14 : DCB.BaudRate:= CBR_256000
    else
      DCB.BaudRate:= CBR_9600;
  end;

  case ComboBox3.ItemIndex of
    0 : DCB.ByteSize:= DATABITS_5;
    1 : DCB.ByteSize:= DATABITS_6;
    2 : DCB.ByteSize:= DATABITS_7;
    3 : DCB.ByteSize:= DATABITS_8;
  else DCB.ByteSize:= DATABITS_8;
  end;

  case ComboBox4.ItemIndex of
    0 : DCB.Parity:= NOPARITY;
    1 : DCB.Parity:= ODDPARITY;
    2 : DCB.Parity:= EVENPARITY;
    3 : DCB.Parity:= MARKPARITY;
    4 : DCB.Parity:= SPACEPARITY;
  else DCB.Parity:= NOPARITY;
  end;

  case ComboBox5.ItemIndex of
    0 : DCB.Stopbits:= ONESTOPBIT;
    1 : DCB.Stopbits:= ONE5STOPBITS;
    2 : DCB.Stopbits:= TWOSTOPBITS;
  else DCB.Stopbits:= ONESTOPBIT;
  end;

  ResBool:=SetCommState(hComm,DCB);
  if not ResBool then
  begin
    SysErrorMessage(GetLastError);
    CloseHandle(hComm);
    hComm:=0;
    exit;
  end;

  CommTimeouts.ReadIntervalTimeout:=MAXDWORD;
  CommTimeouts.ReadTotalTimeoutMultiplier:=0;
  CommTimeouts.ReadTotalTimeoutConstant:=0;
  CommTimeouts.WriteTotalTimeoutMultiplier:=0;
  CommTimeouts.WriteTotalTimeoutConstant:=0;

  ResBool:=SetCommTimeouts(hComm,CommTimeouts);
  if ResBool = false then
  begin
    SysErrorMessageC;
    CloseHandle(hComm);
    hComm:=0;
    exit;
  end;

  Timer1.Enabled:=true;
  //  
  if hReadCom = INVALID_HANDLE_VALUE then
  begin
  //   
    CloseHandle(hReadCom);
    SysErrorMessageC;
    CloseHandle(hComm);
    hComm:=0;
    exit;
  end
  else
  // .  
  Begin
    ResumeThread(ThreadID);
    Button1.Enabled:=false;
    Button2.Enabled:=true;
    ComboBox1.Enabled:=false;
    ComboBox2.Enabled:=false;
    ComboBox3.Enabled:=false;
    ComboBox4.Enabled:=false;
    ComboBox5.Enabled:=false;
    Edit1.ReadOnly := false;
    CheckBox1.Enabled:=true;
    CheckBox2.Enabled:=true;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Timer1.Enabled:=false;
  if hComm <> 0 then
    CloseHandle(hComm);
  hComm:=0;
  CloseHandle(hReadCom);
  hReadCom:=0;

  Button1.Enabled:=true;
  Button2.Enabled:=false;
  ComboBox1.Enabled:=true;
  ComboBox2.Enabled:=true;
  ComboBox3.Enabled:=true;
  ComboBox4.Enabled:=true;
  ComboBox5.Enabled:=true;
  CheckBox1.Enabled:=false;
  CheckBox2.Enabled:=false;
  Edit1.ReadOnly := true;
  Caption := ProgrammVersion;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Ch : Char;
begin
  Edit1KeyPress(Sender,Ch);
  Memo1.Text:=Memo1.Text+Ch;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Memo1.Clear;
end;

//**************

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if MessageDlg(' ,     ?',
mtConfirmation, [mbYes, mbNo], 0) = mrNo then
CanClose := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Reg : TRegistry;
  TS : TStrings;
  i : integer;
begin
  ComboBox1.Items.Clear;
//   
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    Reg.OpenKey('hardware\devicemap\serialcomm', false);
    TS := TStringList.Create;
    try
      Reg.GetValueNames(TS);
      for i := 0 to TS.Count -1 do
        ComboBox1.Items.Add(Reg.ReadString(TS.Strings[i]));
    finally
      TS.Free;
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;

//  ComboBox1   
  ComboBox1.ItemIndex:=0;

// 
  Application.Title:=ProgrammVersion;
  Caption:=ProgrammVersion;
  Button2.Enabled:=false;
  Button2Click(Sender);
end;

procedure Finisher;
begin
  if hComm <> 0 then
    CloseHandle(hComm);
  if hReadCom <> 0 then
    CloseHandle(hReadCom);
end;

//*******CheckBox*******

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.Checked<>false then
    ResBool:=EscapeCommFunction(hComm,SETDTR)
  else
    ResBool:=EscapeCommFunction(hComm,CLRDTR);
  if ResBool = false then
    SysErrorMessage(GetLastError);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
if CheckBox1.Checked<>false then
    ResBool:=EscapeCommFunction(hComm,SETRTS)
  else
    ResBool:=EscapeCommFunction(hComm,CLRRTS);
  if ResBool = false then
    SysErrorMessage(GetLastError);
end;

//*******ComboBox*******

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
Statusbar1.Panels[0].Text := combobox1.Text ;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
Statusbar1.Panels[1].Text := combobox2.Text ;
end;

//**************

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    ReadFile(hComm,inChar,High(inChar),ReadenBytes,Nil); //!!!
  if inChar <> '' then  //  ...
  begin
  //   String ...
    Memo1.Text := Memo1.Text + inChar;
    Memo1.Perform(WM_VScroll, SB_BOTTOM,0); //  
  end;
  inChar:='';
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  Result: Cardinal;
begin
  GetCommModemStatus(hComm,Result);

  if (Result and MS_CTS_ON)<>0 then
    CheckBox3.Checked:=true
  else
    CheckBox3.Checked:=false;

  if (Result and MS_DSR_ON)<>0 then
    CheckBox4.Checked:=true
  else
    CheckBox4.Checked:=false;

  if (Result and MS_RING_ON)<>0 then
    CheckBox5.Checked:=true
  else
    CheckBox5.Checked:=false;

  if (Result and MS_RLSD_ON)<>0 then
    CheckBox6.Checked:=true
  else
    CheckBox6.Checked:=false;

  GetCommProperties(hComm,CommProp);
  case CommProp.dwProvSubType of
    PST_FAX: StatusBar1.Panels[2].Text:=': FAX device';
    PST_LAT: StatusBar1.Panels[2].Text:=': LAT protocol';
    PST_MODEM: StatusBar1.Panels[2].Text:=': Modem device';
    PST_NETWORK_BRIDGE:	StatusBar1.Panels[2].Text:=': Unspecified network bridge';
    PST_PARALLELPORT:	StatusBar1.Panels[2].Text:=': Parallel port';
    PST_RS232: StatusBar1.Panels[2].Text:=': RS-232 serial port';
    PST_RS422: StatusBar1.Panels[2].Text:=': RS-422 port';
    PST_RS423: StatusBar1.Panels[2].Text:=': RS-423 port';
    PST_RS449: StatusBar1.Panels[2].Text:=': RS-449 port';
    PST_SCANNER: StatusBar1.Panels[2].Text:=': Scanner device';
    PST_TCPIP_TELNET:	StatusBar1.Panels[2].Text:=': TCP/IP Telnet protocol';
    PST_UNSPECIFIED: StatusBar1.Panels[2].Text:=':  ';
    PST_X25: StatusBar1.Panels[2].Text:=': X.25 standards'
    else
    StatusBar1.Panels[2].Text:=':  ';
  end;
 end;

//*******Memo*******


//******* *******

procedure TForm1.N3Click(Sender: TObject);
begin
{with TOptionsPort.Create(nil) do
  begin
    Position := poScreenCenter;
    ShowModal;
    Free;
  end;}
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  with TAboutForm.Create(nil) do
  begin
    Position := poScreenCenter;
    ShowModal;
    Free;
  end;
end;

procedure TForm1.N5Click(Sender: TObject);
begin
close;
end;

//*******Edit*******

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
TransmitCommChar(hComm,Key);
//   
if not (Key in ['0'..'9', ',']) then Key:=#0;
Edit1.text:=' ';
//   . ,     
//Edit1.SetFocus;
//Edit1.SelStart:=0;
//Edit1.SelLength:=1;
end;

end.



